--------------------------------------------------
-- LuaStorageScript.lua
-- 	2015/08/25 - 2015/08/27
-- 					hksy
--------------------------------------------------

if(LuaStorage==nil)then
	LuaStorage	= {}
end

function LuaStorage.StrDump(t, depth)
	local type	= type
	local d	= "{"
	depth	= depth	or 1

	for key,value in pairs(t) do
		local kt	= type(key)
		local vt	= type(value)
		local ks	= ""
		local vs	= ""
		local isWrite	= true

		-- key
		if(kt=="number")then
			ks	= "[" .. key .. "]="
		elseif(kt=="string")then
			ks	= key .. "="
		end

		-- value
		if(vt=="number")then
			vs	= value .. ""
		elseif(vt=="string")then
			local v	= value
			v	= v:gsub("\\","\\\\")
			v	= v:gsub("\"","\\\"")
			vs	= "\"" .. v .. "\""
		elseif(vt=="table")then
			if(depth<50)then
				vs	= LuaStorage.StrDump(value, depth+1)
			end
		elseif(vt=="boolean")then
			if(value)then
				vs	= "true"
			else
				vs	= "false"
			end
		elseif(vt=="nil")then
			vs	= "nil"
		else
			isWrite	= false
		end

		if(isWrite)then
			d	= d .. ks .. vs .. ";"
		end
	end
	return d .. "}"

end

function LuaStorage.Save(t)
	return LuaStorage.StrDump(t)
end

function LuaStorage.Load(str)
	local ls	= loadstring("return " .. str)()
	for key,value in pairs(ls) do
		LuaStorage[key]	= value
	end
end

